/* 
 * Copyright (C) 2006 Registro.br. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * 1. Redistribution of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY REGISTRO.BR ``AS IS AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIE OF FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
 * EVENT SHALL REGISTRO.BR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 */
/* $Id: StrUtil.cpp 400 2006-02-10 17:04:31Z eduardo $ */

#include "config.h"

#include "StrUtil.H"

LIBEPP_NICBR_NS_BEGIN

string StrUtil::parse(const string &text,
		      const map < string, string, less<string> > &to_parse, 
		      string tag_begin, string tag_end)
{
  string result = text;
  string buffer;
  map<string, string, less<string> >::const_iterator it;

  for (it = to_parse.begin(); it != to_parse.end(); it++) {
    buffer = tag_begin + (*it).first + tag_end;
    gsub(result, buffer.c_str(), (*it).second.c_str());
  }

  return result;
}

int StrUtil::gsub(string &buffer, const char *pat, const char *drp)
{
  int i = 0;
  int count = 0;

  do {
    i = buffer.find(pat,i);
    if (i == -1) {
      break;
    }

    count++;
    buffer.replace(i,strlen(pat),drp);
    i += strlen(drp);
  } while (i < (int)buffer.length());

  return count;
}

LIBEPP_NICBR_NS_END
